<template>
    <div class="math-model-settings">
      <div class="settings-form">
        <settings-modal @change="updateModel" :model="model" />
      </div>
      <div class="submit-form">
          <ObFormControls
              ok-text="Сохранить"
              :is-error="formInvalid"
              :isSubmitDisabled="!mathModelChanged || formInvalid"
              @submit="saveSettings"
              @cancel="resetModel"
          />
      </div>

    </div>
</template>

<script>
// import api from '@/api'
import ObFormControls from "common-components/src/obComponents/obForm/ObFormControls"
import SettingsModal from './SettingsModal';
import { mapGetters, mapActions } from 'vuex';

export default {
  name: 'MathModel',
  components: {
    SettingsModal,
    ObFormControls,
  },
  data() {
    return {
      modalId: 0,
    };
  },
  computed: {
    ...mapGetters({
      formInvalid: 'base_prices/mathModelInvalid',
      mathModelChanged: 'base_prices/mathModelChanged',
      model: 'base_prices/mathModel',
    }),
  },
  async created() {
    await this.getMathModel();
  },
  beforeDestroy() {
    this.resetValidationState();

    setTimeout(() => {
      this.modalId++;
      this.$nextTick(() => {
        this.clearMathModel();
      });
    }, 300);
  },
  methods: {
    ...mapActions({
      resetValidationState: 'base_prices/resetValidationState',
      getMathModel: 'base_prices/getMathModel',
      updateMathModel: 'base_prices/updateMathModel',
      clearMathModel: 'base_prices/clearMathModel',
    }),
    resetModel() {
      this.resetValidationState();
      this.getMathModel();
    },
    modalClosed() {
      this.resetValidationState();

      setTimeout(() => {
        this.modalId++;
        this.$nextTick(() => {
          this.clearMathModel();
        });
      }, 300);
    },
    async saveSettings() {
      let notificationId = new Date().getTime() + 'save';
      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId,
        });

        await this.updateMathModel();
        this.resetValidationState();

        this.$notification({
          type: 'system_notification_success',
          message: `Настройки успешно сохранены`,
        });
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: e.error_message || 'Не сохранено',
        });
      } finally {
        this.$notification({ event: 'close', id: notificationId });
      }
      this.$refs.settings.close();
    },
    updateModel(param, value) {
      this.model[param] = value;
    },
    async openMathModal() {
      this.$refs.settings.open();
    },
  },
};
</script>

<style lang="scss" scoped>

.math-model-settings{
  padding: 30px 20px;
}
.settings-form{
  width: 800px;
  max-width: 100%;
}
.submit-form{
  margin-top: 30px;
  //width: 250px;
  max-width: 100%;
}

::v-deep {
  .row.middle-xs{
    margin-bottom: 10px;
  }
}

</style>
